////////////////////////////////////////////////////////////////////////
// recordings.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.recordings")

// <%pre>
#line 1 "recordings.ecpp"


#include <string>
#include <string_view>
#include <setup.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>
#include <recman.h>
#include <tntconfig.h>
#include <vdr/channels.h>
#include <stringhelpers.h>
#include <largeString.h>

#ifdef HAVE_PCRE2
#include <StringMatch.h>
#endif
#include <vdr/videodir.h>

#define MB_PER_MINUTE 25.75 // this is just an estimate!

using namespace vdrlive;


#line 1 "page_init.eh"

// do not add to Makefile
// and do not write a ecpp comment into this file. It must produce no
// html output not even an empty line.
#include <tnt/savepoint.h>
#include <exception.h>

#line 2 "page_exit.eh"

#include <exception.h>

// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class recordings_item_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        recordings_item_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class sort_options_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        sort_options_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class setactive_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        setactive_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class del_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        del_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_rec_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_rec_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class todel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        todel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class rec_tools_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        rec_tools_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class archived_disc_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        archived_disc_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class delete_error_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        delete_error_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    recordings_item_type recordings_item;
    sort_options_type sort_options;
    setactive_type setactive;
    del_rec_type del_rec;
    edit_rec_type edit_rec;
    todel_type todel;
    rec_tools_type rec_tools;
    archived_disc_type archived_disc;
    delete_error_type delete_error;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("recordings");

static const char* rawData = "\134\003\000\000]\003\000\000^\003\000\000_\003\000\000\321\003\000\000\336\003\000\000"
  "\343\003\000\000\350\003\000\000\025\004\000\0008\004\000\000U\004\000\000\030\005\000\000 \005\000\000&\005\000\0008"
  "\005\000\000u\005\000\000\233\005\000\000\336\007\000\000g\010\000\000\335\010\000\000L\t\000\000c\t\000\000\367\n"
  "\000\000[\015\000\000_\015\000\000c\015\000\000g\015\000\000k\015\000\000n\015\000\000\015\016\000\000c\016\000\000f"
  "\016\000\000\262\016\000\000\265\016\000\000\327\016\000\000$\017\000\000p\017\000\000s\017\000\000\240\017\000\000"
  "\350\020\000\000\365\020\000\000\001\021\000\000\024\021\000\000\301\021\000\000\302\021\000\000\304\021\000\000\305"
  "\021\000\000\307\021\000\000\310\021\000\000\004\022\000\000\027\022\000\000\035\022\000\000\036\022\000\000\344\022"
  "\000\0000\023\000\000a\023\000\000\220\023\000\000\313\023\000\000%\024\000\000/\024\000\000M\024\000\000f\024\000"
  "\000g\024\000\000h\024\000\000j\024\000\000\314\024\000\000\357\024\000\000D\025\000\000u\025\000\000\303\025\000\000"
  "!\026\000\000G\026\000\000\262\026\000\000\315\026\000\000\t\027\000\0001\027\000\000>\027\000\000~\027\000\000\271"
  "\027\000\000\332\027\000\000\345\027\000\000\352\027\000\000\355\027\000\000\357\027\000\000\373\027\000\000\034\030"
  "\000\0004\030\000\000C\030\000\000f\030\000\000h\030\000\000l\030\000\000r\030\000\000\206\030\000\000\214\030\000"
  "\000\216\030\000\000\222\030\000\000\226\030\000\000\252\030\000\000\273\030\000\000\300\030\000\000\303\030\000\000"
  "\305\030\000\000\325\030\000\0007\031\000\000\225\031\000\000\363\031\000\000G\032\000\000\211\032\000\000\347\032"
  "\000\000\365\032\000\000-\033\000\000.\033\000\000/\033\000\000H\033\000\000o\033\000\000w\033\000\000}\033\000\000"
  "\177\033\000\000\201\033\000\000\277\033\000\000\307\033\000\000\315\033\000\000\317\033\000\000\321\033\000\000!\034"
  "\000\000'\034\000\000)\034\000\000+\034\000\0000\034\000\000i\034\000\000q\034\000\000w\034\000\000y\034\000\000z\034"
  "\000\000\177\034\000\000\263\034\000\000\342\034\000\000\022\035\000\000\026\035\000\000\"\035\000\000*\035\000\000e"
  "\035\000\000n\035\000\000\223\035\000\000\234\035\000\000\237\035\000\000\246\035\000\000\247\035\000\000\250\035\000"
  "\000\266\035\000\000\267\035\000\000\270\035\000\000\330\035\000\000\336\035\000\000\346\035\000\000\354\035\000\000"
  "\376\035\000\000\000\036\000\000\013\036\000\000\032\036\000\000\033\036\000\000\034\036\000\000\?\036\000\000E\036"
  "\000\000M\036\000\000S\036\000\000e\036\000\000q\036\000\000z\036\000\000\201\036\000\000\202\036\000\000\203\036\000"
  "\000\265\036\000\000\314\036\000\000\361\036\000\000A\037\000\000\254\037\000\000\356\037\000\000m \000\000\177 \000"
  "\000\301 \000\000\371 \000\000\374 \000\000\377 \000\0006!\000\000\304!\000\000\365!\000\0005\"\000\0008\"\000\000k\""
  "\000\000m\"\000\000n\"\000\000o\"\000\000p\"\000\000q\"\000\000r\"\000\000s\"\000\000\270\"\000\000\372\"\000\000\375"
  "\"\000\000\377\"\000\000\002#\000\000\006#\000\000\n#\000\000\015#\000\000\031#\000\000\032#\000\000\033#\000\000%#"
  "\000\0004#\000\0008#\000\0009#\000\000:#\000\000;#\000\000<#\000\000\n\n\n\n<html>\n  <head>\n    <meta name=\"viewpo"
  "rt\" content=\"width=device-width, initial-scale=1\" />\n    <title>VDR-Live - </title>\n    \n    \n    \n<script>\n"
  "const recs = [];\nconst vdr_start = ;\nconst recordings_tree_creation = ;\nconst param_name_recs = '&r=';\nconst rec_"
  "ids = Object.create(null)\nrec_ids[\"T\"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a"
  " href=\"'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=&filter=&flat=&history_num_back=\" title="
  "\"'\n  s.a += Title\n  s.a += '\"><img class=\"icon\" src=\"'\n  s.a += Img\n  s.a += '\" /></a>'\n}\n\n\nfunction Re"
  "cordingsSt_int(s, level, displayFolder, data) {\n  s.a += '<li class=\"recording\"><div>'\n  s.a += '<table width=\"1"
  "00%\" class=\"recordings\">'\n  for (obj_i of data) {\n    if (typeof recs[obj_i] === 'undefined') continue;\n    obj"
  " = recs[obj_i]\n    s.a += '<tr class=\"recording_item\">'\n    if (level > 0) s.a += \n      '<td class=\"space\"> <"
  "img src=\"img/transparent.png\" width=\"' + String(16 * level) + 'px\" height=\"16px\" /></td>'\n    s.a += '<td clas"
  "s=\"td-hidden-xs\"><div class=\"hidden-xs recording_imgs\">'\n    if (obj[1].length != 0) {\n      s.a += '<img class"
  "=\"icon\" src=\"on_dvd.png\" alt=\"on_dvd\" title=\"'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s."
  "a += '<input type=\"checkbox\" name=\"deletions\" value=\"recording_'\n      s.a += obj[0]\n      s.a += '\" />'\n   "
  " }\n    s.a += '</div></td>'  // end of recording_imgs\n    s.a += '<td class=\"space\">'\n      addScraperImageTitle"
  "(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n    s.a += '<td class=\"td-hidden-xs\">"
  "<div class=\"hidden-xs recording_day margin-bottom\">'\n    s.a += obj[9]\n    s.a += '</div><div class=\"hidden-xs r"
  "ecording_channel\">'\n    s.a += obj[12]\n    s.a += '</div></td><td class=\"td-hidden-xs\" style=\"text-align:right"
  "\"><div class=\"hidden-xs recording_duration margin-bottom\">'\n    s.a += obj[19]\n    if (obj[17] > 0) {\n      s.a"
  " += '<span title=\"'\n      s.a += ''\n      s.a += '\"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a +"
  "= '</span>'\n    }\n    s.a += '</div><div class=\"hidden-xs recording_size\">'\n    s.a += obj[20]\n    s.a += '</di"
  "v></td><td>'\n    addErrorIcon(s, obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a "
  "+= '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class=\"recording_name'\n    s.a += obj[13]"
  "\n    s.a += '\">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class=\"with"
  "margin\">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '', '', '', '', '', );\n    s"
  ".a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><div class=\"recording_actio"
  "ns\">'\n    if (obj[1].length == 0) {\n        RecordingActionS(s, obj[0], \"vdr_request/play_recording\?param=\", \""
  "play.png\", \"\")\n        RecordingActionS(s, obj[0], \"playlist.m3u\?recid=\", \"playlist.png\", \"\")\n        IMD"
  "BS(s, obj[2], obj[14])\n      RecordingActionS(s, obj[0], \"edit_recording.html\?recid=\", \"edit.png\", \"\")\n     "
  " RecordingActionS(s, obj[0], \"epginfo.html\?epgid=del_\", \"del.png\", \"\")\n    } else {\n      IMDBS(s, obj[2], o"
  "bj[14])\n    }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class=\"recording_arch\">'\n  "
  "    s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\n<"
  "/script>\n\n  <script type=\"text/javascript\" src=\"js/live/treeview.js\"></script>\n  <script>\n  const tv = new Tr"
  "eeview(\"minus.png\", \"plus.png\", \"folder_open.png\", \"folder_closed.png\");\n  </script>\n</head>\n<body onload="
  "\"adjustHeader()\" onresize=\"adjustHeader()\" onpageshow=\"clearCheckboxes(document.getElementById('form_recordings'"
  "))\">\n  \n  \n  \n  <div class=\"inhalt\">\n    <div class=\"boxheader\"><div><div></div></div></div>\n      \n     "
  " <form method=\"post\" name=\"recordings\" id=\"form_recordings\" action=\"recordings.ecpp\">\n        <div class=\"r"
  "ecordings\">\n          <ul class=\"recordingslist\" style=\"display: block;\">\n            \n          </ul>\n     "
  "   </div>\n\t\t\t\t<input type=\"hidden\" name=\"sort\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"filter\" v"
  "alue=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"flat\" value=\"\">\n\t\t\t\t<input type=\"hidden\" name=\"history_n"
  "um_back\" value=\"\">\n        <div class=\"withmargin hidden-xs\">\n          <button class=\"red\" type=\"submit\">"
  "</button>\n\n        </div>\n      </form>\n  </div>\n</body>\n</html>\n\n\n\n\n      <li class=\"recording\">\n     "
  "   <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">\n        <table><tr>\n                      "
  "<td class = \"space\">\n              <img src=\"img/transparent.png\" width=\"px\" height=\"16px\" />\n            <"
  "/td>\n                    <td class=\"space\">\n            <img class=\"recording_expander\" src=\"plus.png\" />\n  "
  "        </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_closed.png\" />\n        "
  "  </td>\n            <td class = space>\n              <div class=\"thumb\">\n                <img data-src=\"/tvscra"
  "per/\"\n                  class=\"\"\n                />\n              </div>\n            </td>\n        <td class="
  "\"recording_folder_name\">\n          \n        </td></tr></table>\n        </div>\n        <ul id=\"fldr_\" class=\""
  "recordingslist\" style=\"display: none;\">\n          \n        </ul>\n      </li>\n      <script>\n  recs[]=[]\n</sc"
  "ript>\n      <script>\n      rec_ids[\"fldr_\"] = []\n    </script>\n        <script>\n      document.write(rec_strin"
  "g_d([, , [  ]]))\n      rec_ids[\"fldr_\"] = [, , [  ]]\n      </script>\n    <script>\n        recs[]=[]\n</script>"
  "\n            <li class=\"recording\">\n        <div class=\"recording_item\" onclick = \"tv.Toggle(this, 'fldr_')\">"
  "\n          <table><tr><td class=\"space\">\n            <img class=\"recording_expander\" src=\"plus.png\" />\n     "
  "     </td><td class=\"space\">\n            <img class=\"recording_folder\" src=\"folder_closed.png\" />\n          <"
  "/td><td class=\"recording_folder_name\">\n            \n          </td></tr></table>\n        </div>\n        <ul id="
  "\"fldr_\" class=\"recordingslist\" style=\"display: none;\">\n          <script>\n            rec_ids[\"fldr_\"] = [1"
  ", 1, [  ]]\n          </script>\n        </ul>\n      </li>\n      \n\n<span class=\"label bold\"> </span>\n<a href="
  "\"recordings.html\?sort=&filter=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filte"
  "r=&flat=\"  ></a>\n<span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=duplicates&filter=&flat=\"  ></a>\n<"
  "span class=\"sep\">|</span>\n<a href=\"recordings.html\?sort=&filter=&flat=\" ></a>\n<span class=\"sep\">|</span>\n<s"
  "pan class=\"label bold\">:&nbsp;<input type=\"text\" name=\"filter\" value=\"\" id=\"filter\" onchange=\"filterRecord"
  "ings(this, '', '')\" />&nbsp;</span>\n<span class=\"sep\">|</span>\n<img onclick=\"ExpandAll()\" src=\"\" alt=\"\" />"
  "\n<img onclick=\"CollapseAll()\" src=\"\" alt=\"\" />\n<br />\n\n\nclass=\"active\"\n\n<a href=\"epginfo.html\?epgid="
  "del_&sort=&filter=&flat=&history_num_back=\" ><img src=\"\" alt=\"\" /></a>\n\n<a href=\"edit_recording.html\?recid=&"
  "sort=&filter=&flat=&history_num_back=\"><img src=\"\" alt=\"\"  /></a>\n\n<!DOCTYPE html>\n<html>\n  <script>\n    hi"
  "story.go(-);\n  </script>\n</html>\n<div class=\"epg_description\" id=\"del_\">\n  <div class=\"station\">\n    <div "
  "class=\"boxheader\"><div><div class=\"caption\"></div></div></div>\n  </div>\n  <div class=\"epg_content\">\n    <for"
  "m>\n      <div class=\"about_head\"><div><div></div></div></div>\n      <input type=\"hidden\" name=\"epgid\" value="
  "\"\" >\n      <input type=\"hidden\" name=\"delete_rec\" value=\"confirmed\" >\n      <input type=\"hidden\" name=\"h"
  "istory_num_back\" value=\"\" id=\"history_del_\">\n      <div class=\"about_left\">\n        <button id=\"confirm_del"
  "_\" class=\"green\" type=\"button\" onclick=\"delete_rec_back('', )\"></button>\n      </div>\n      <div class=\"abo"
  "ut_right\">\n\n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf(\"epginfo.html\?\") != -1) {\n  "
  "  history.go(-1);\n  } else {\n    history.go(-);\n  }\n}\n</script>\n        <button id=\"close_del_\" type=\"button"
  "\" class=\"red\" onclick=\"back_depending_referrer(1, )\"></button>\n      </div>\n    </form>\n  </div>\n</div>\n\n"
  "\n\n\n\n\n\n\n<img data-src=\"img/transparent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n<script class=\""
  "injectIcons\">\ninjectErrorHdSdIcon(\"icons-\", , , \"\", \"\", \"\", )\n</script>\n\n\n<img src=\"\" alt=\"on_dvd\" "
  " />\n\n\n\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    recordings_item(*this, "recordings_item"),
    sort_options(*this, "sort_options"),
    setactive(*this, "setactive"),
    del_rec(*this, "del_rec"),
    edit_rec(*this, "edit_rec"),
    todel(*this, "todel"),
    rec_tools(*this, "rec_tools"),
    archived_disc(*this, "archived_disc"),
    delete_error(*this, "delete_error")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string sort = qparam.get< std::string >("sort");
std::string todel = qparam.get< std::string >("todel");
std::string diskinfo = qparam.get< std::string >("diskinfo");
std::string filter = qparam.get< std::string >("filter");
std::vector< std::string > deletions = qparam.getvector< std::string >("deletions");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n
  reply.out() << _tntChunks[2]; // \n
  // <%include> page_init.eh
#line 11 "page_init.eh"

try {
	reply.setHeader("Expires", "Mon, 26 Jul 1997 05:00:00 GMT");
	tnt::Savepoint spoint( reply );

  // </%include>
#line 47 "recordings.ecpp"

std::chrono::time_point<std::chrono::high_resolution_clock> timeStart = std::chrono::high_resolution_clock::now();

reply.setHeader (tnt::httpheader::cacheControl, "no-store, no-cache, max-age=0, must-revalidate, proxy-revalidate", true);
if (!logged_in && LiveSetup().UseAuth()) return reply.redirect("login.html");

if (request.getMethod() != "POST") history_num_back = 0;  // we can go back in history to this page
else ++history_num_back;  // we have to go back in history to a prev page, to avoid re-send of form data

// create the "current" values of the global request parameters, based on their old values and the current arguments
// basically, this is a bad idea. Pushing "refresh" changes the sort order :( .
// Better: Urls on menue have parameters depending on the current sort option
if (! flat.empty() ) currentFlat = flat;
// sort depends on old sort, and sort parameter
currentSort = LiveSetup().GetLastSortingMode();
if (currentSort.empty() ) currentFlat == "true"?currentSort = "errorsts":currentSort = "datedesc";
if (!sort.empty()) {
  if (sort == "date")
    currentSort = (currentSort == "datedesc") ? "dateasc" : "datedesc";
  else if (sort == "datedesc" || sort == "dateasc") currentSort = sort;
  else if (sort == "name")
    currentSort = (currentSort == "nameasc") ? "namedesc" : "nameasc";
  else if (sort == "nameasc" || sort == "namedesc") currentSort = sort;
  else if (sort == "errors")
    currentSort = (currentSort == "errorsts") ? "errorsdur" : "errorsts";
  else if (sort == "errorsts" || sort == "errorsdur") currentSort = sort;
  else if (sort == "duplicates")
    currentSort = sort;
  LiveSetup().SetLastSortingMode(currentSort);
}
currentFilter = filter;

pageTitle = tr("Recordings");

deleteResult = "";
if (!todel.empty()) {
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  deletions.push_back(todel);
}
for (auto it = deletions.begin(); it != deletions.end(); ++it) {
  if (cUser::CurrentUserHasRightTo(UR_DELRECS)) {
    RemoveRecordingTask task(*it);
    LiveTaskManager().Execute(task);
/*
    if (!task.Result())
    deleteResult += std::string() + tr("ERROR:") + " " + task.Error() + "<br/>";
    else
*/
    if (task.Result())
      deleteResult += std::string() + tr("Deleted recording:") + " " + StringReplace(task.RecName(), "~", "/") + "<br/>";
  }
  else {
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  }
}
deletions.clear();

int FreeMB, UsedMB;
int Percent = cVideoDirectory::VideoDiskSpace(&FreeMB, &UsedMB);
int Minutes = int(double(FreeMB) / MB_PER_MINUTE);
int Hours = Minutes / 60;
Minutes %= 60;
diskinfo = cString::sprintf("%s %d%%  -  %2d:%02d %s", trVDR("Disk"), Percent, Hours, Minutes, trVDR("free"));
#if TNTVERSION >= 30000
const char *TNT_ARRAY = "[]";
#else
const char *TNT_ARRAY = "";
#endif
const char *lf = "<br/>";


RecordingsTreePtr recordingsTree(LiveRecordingsManager()->GetRecordingsTree());

// get data for all open nodes
std::vector<int> available_recs;
std::string openTreeNodes;
if (request.hasCookie("VDR-Live-Recordings-Tree-Open-Nodes")) {
  openTreeNodes = request.getCookie("VDR-Live-Recordings-Tree-Open-Nodes");
//  isyslog("live: VDR-Live-Recordings-Tree-Open-Nodes = %s", openTreeNodes.c_str());
}
cLargeString recoring_item("recoring_item", 25000);

  // <& pageelems.doc_type ...
  { 
#line 130 "recordings.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 130 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "doc_type"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[3]; // \n<html>\n  <head>\n    <meta name="viewport" content="width=device-width, initial-scale=1" />\n    <title>VDR-Live - 
#line 134 "recordings.ecpp"
  reply.sout() << ( pageTitle );
  reply.out() << _tntChunks[4]; // </title>\n    
  // <& pageelems.stylesheets ...
  { 
#line 135 "recordings.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 135 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "stylesheets"), request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[5]; // \n    
  // <& pageelems.create_html_js ...
  { 
#line 136 "recordings.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 136 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "create_html_js"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[6]; // \n    
  // <& pageelems.ajax_js ...
  { 
#line 137 "recordings.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 137 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_js"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[7]; // \n<script>\nconst recs = [];\nconst vdr_start = 
#line 140 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvInt(LiveSetup().GetVdrStart() )) );
  reply.out() << _tntChunks[8]; // ;\nconst recordings_tree_creation = 
#line 141 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvInt(recordingsTree->getCreationTimestamp() )) );
  reply.out() << _tntChunks[9]; // ;\nconst param_name_recs = '&r
#line 142 "recordings.ecpp"
  reply.sout() << ( TNT_ARRAY );
  reply.out() << _tntChunks[10]; // =';\nconst rec_ids = Object.create(null)\nrec_ids["T"] = [1, 2]\n\nfunction RecordingActionS(s, id, A, Img, Title) {\n  s.a += '<a href="'\n  s.a += A\n  s.a += 'recording_'\n  s.a += id\n  s.a += '&sort=
#line 151 "recordings.ecpp"
  reply.sout() << (currentSort);
  reply.out() << _tntChunks[11]; // &filter=
#line 151 "recordings.ecpp"
  reply.sout() << (currentFilter);
  reply.out() << _tntChunks[12]; // &flat=
#line 151 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[13]; // &history_num_back=
#line 151 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[14]; // " title="'\n  s.a += Title\n  s.a += '"><img class="icon" src="
#line 153 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[15]; // '\n  s.a += Img\n  s.a += '" /></a>'\n}\n\n
  reply.out() << _tntChunks[16]; // \nfunction RecordingsSt_int(s, level, displayFolder, data) {\n  s.a += '<li class="recording"><div>'\n  s.a += '<table width="100%" class="recordings">'\n  for (obj_i of data) {\n    if (typeof recs[obj_i] === 'undefined') continue;\n    obj = recs[obj_i]\n    s.a += '<tr class="recording_item">'\n    if (level > 0) s.a += \n      '<td class="space"> <img src="img/transparent.png" width="' + String(16 * level) + 'px" height="16px" /></td>'\n    s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_imgs">'\n    if (obj[1].length != 0) {\n      s.a += '<img class="icon" src="
#line 196 "recordings.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[17]; // on_dvd.png" alt="on_dvd" title="'\n      s.a += obj[1]\n      s.a += '/>'\n    } else {\n      s.a += '<input type="checkbox" name="deletions
#line 200 "recordings.ecpp"
  reply.sout() << (TNT_ARRAY);
  reply.out() << _tntChunks[18]; // " value="recording_'\n      s.a += obj[0]\n      s.a += '" />'\n    }\n    s.a += '</div></td>'  // end of recording_imgs\n
#line 205 "recordings.ecpp"
   if (!LiveSetup().GetTvscraperImageDir().empty() ) {

  reply.out() << _tntChunks[19]; //     s.a += '<td class="space">'\n      addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 207 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[20]; // ');\n    s.a += '</td>'\n
#line 209 "recordings.ecpp"
   }

  reply.out() << _tntChunks[21]; //     s.a += '<td class="td-hidden-xs"><div class="hidden-xs recording_day margin-bottom">'\n    s.a += obj[9]\n    s.a += '</div><div class="hidden-xs recording_channel">'\n    s.a += obj[12]\n    s.a += '</div></td><td class="td-hidden-xs" style="text-align:right"><div class="hidden-xs recording_duration margin-bottom">'\n    s.a += obj[19]\n    if (obj[17] > 0) {\n      s.a += '<span title="'\n      s.a += '
#line 218 "recordings.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[22]; // '\n      s.a += '"> ['\n      addTime(s, obj[17])\n      s.a += ']'\n      s.a += '</span>'\n    }\n    s.a += '</div><div class="hidden-xs recording_size">'\n    s.a += obj[20]\n    s.a += '</div></td><td>'\n    addErrorIcon(s, obj[10], obj[17], obj[19], obj[21])\n    addHdSdIcon(s, obj[11], obj[12])\n    s.a += '</td>'  // end column with error / sd/hd image\n    s.a += '<td><div class="recording_name'\n    s.a += obj[13]\n    s.a += '">'\n    if (displayFolder == 1) folder = obj[18]\n    else folder = ''\n    s.a += '<div class="withmargin">'\n    addEventRec(s, 'recording_', obj[0], obj[14], folder, obj[15], obj[16], '
#line 236 "recordings.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[23]; // ', '
#line 236 "recordings.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[24]; // ', '
#line 236 "recordings.ecpp"
  reply.sout() << ( sort );
  reply.out() << _tntChunks[25]; // ', '
#line 236 "recordings.ecpp"
  reply.sout() << ( filter );
  reply.out() << _tntChunks[26]; // ', '
#line 236 "recordings.ecpp"
  reply.sout() << ( flat );
  reply.out() << _tntChunks[27]; // ', 
#line 236 "recordings.ecpp"
  reply.sout() << ( history_num_back+1 );
  reply.out() << _tntChunks[28]; // );\n    s.a += '</div></div></td>'  // end if recording_name / short description\n    s.a += '<td><div class="recording_actions">'\n    if (obj[1].length == 0) {\n
#line 240 "recordings.ecpp"
     if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[29]; //         RecordingActionS(s, obj[0], "vdr_request/play_recording\?param=", "play.png", "
#line 241 "recordings.ecpp"
  reply.sout() << (tr("play this recording"));
  reply.out() << _tntChunks[30]; // ")\n
#line 242 "recordings.ecpp"
     }

#line 243 "recordings.ecpp"
     if (LiveSetup().GetShowPlayMediaplayer() ) {

  reply.out() << _tntChunks[31]; //         RecordingActionS(s, obj[0], "playlist.m3u\?recid=", "playlist.png", "
#line 244 "recordings.ecpp"
  reply.sout() << (tr("Stream this recording into media player."));
  reply.out() << _tntChunks[32]; // ")\n
#line 245 "recordings.ecpp"
     } if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[33]; //         IMDBS(s, obj[2], obj[14])\n
#line 247 "recordings.ecpp"
     }

  reply.out() << _tntChunks[34]; //       RecordingActionS(s, obj[0], "edit_recording.html\?recid=", "edit.png", "
#line 248 "recordings.ecpp"
  reply.sout() << (tr("Edit recording"));
  reply.out() << _tntChunks[35]; // ")\n      RecordingActionS(s, obj[0], "epginfo.html\?epgid=del_", "del.png", "
#line 249 "recordings.ecpp"
  reply.sout() << (tr("Delete this recording from hard disc!"));
  reply.out() << _tntChunks[36]; // ")\n
#line 250 "recordings.ecpp"
     if (LiveSetup().GetShowIMDb() ) {

  reply.out() << _tntChunks[37]; //     } else {\n      IMDBS(s, obj[2], obj[14])\n
#line 253 "recordings.ecpp"
     }

  reply.out() << _tntChunks[38]; //     }\n    s.a += '</div>'\n    if (obj[1].length != 0) {\n      s.a += '<div class="recording_arch">'\n      s.a += obj[1]\n      s.a += '</div>'\n    }\n    s.a += '</td></tr>'\n  }\n  s.a += '</table></div></li>'\n}\n\n</script>\n\n  <script type="text/javascript" src="js/live/treeview.js"></script>\n  <script>\n  const tv = new Treeview("
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[39]; // minus.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[40]; // plus.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[41]; // folder_open.png", "
#line 270 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[42]; // folder_closed.png");\n  </script>\n</head>\n<body onload="adjustHeader()" onresize="adjustHeader()" onpageshow="clearCheckboxes(document.getElementById('form_recordings'))">\n  
  // <& pageelems.logo ...
  { 
#line 274 "recordings.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 274 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "logo"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[43]; // \n
#line 275 "recordings.ecpp"

const char *active_r;
if (flat == "true") active_r = "recordings_flat";
else active_r = "recordings";

if (!deleteResult.empty()) {

  reply.out() << _tntChunks[44]; //   
  // <& menu ...
  { 
#line 282 "recordings.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "active", (active_r));
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "component", "recordings.delete_error");
#line 282 "recordings.ecpp"
    _tnt_cq5.add( "filter", (filter));
#line 282 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[45]; // \n
#line 283 "recordings.ecpp"

} else {

  reply.out() << _tntChunks[46]; //   
  // <& menu ...
  { 
#line 286 "recordings.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "active", (active_r));
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "component", "recordings.sort_options");
#line 286 "recordings.ecpp"
    _tnt_cq6.add( "filter", (filter));
#line 286 "recordings.ecpp"
    callComp(tnt::Compident(std::string(), "menu"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[47]; // \n
#line 287 "recordings.ecpp"

}

  reply.out() << _tntChunks[48]; //   <div class="inhalt">\n    <div class="boxheader"><div><div>
#line 291 "recordings.ecpp"
  reply.sout() << ( std::string(tr("List of recordings")) + " (" + diskinfo + ")" );
  reply.out() << _tntChunks[49]; // </div></div></div>\n
#line 292 "recordings.ecpp"

    int rec_cnt;
    {
      LOCK_RECORDINGS_READ;
      rec_cnt = Recordings->Count();  // Access VDRs global cRecordings Recordings instance.
    }
    if (rec_cnt == 0) {

  reply.out() << _tntChunks[50]; //       
#line 300 "recordings.ecpp"
  reply.sout() << ( tr("No recordings found") );
  reply.out() << _tntChunks[51]; // \n
#line 301 "recordings.ecpp"

    } else {
      uintptr_t irecoring_item = (uintptr_t)&recoring_item;
      RecordingsItemDirPtr recItemRoot = recordingsTree->getRoot();
      uintptr_t iRecItemRoot = (uintptr_t)&recItemRoot;
      uintptr_t iRecordingsTree = (uintptr_t)&recordingsTree;
      uintptr_t iOpenTreeNodes = (uintptr_t)&openTreeNodes;
      uintptr_t iAvailable_recs = (uintptr_t)&available_recs;

  reply.out() << _tntChunks[52]; //       <form method="post" name="recordings" id="form_recordings" action="recordings.ecpp">\n        <div class="recordings">\n          <ul class="recordingslist" style="display: block;">\n            
  // <& recordings.recordings_item ...
  { 
#line 313 "recordings.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 313 "recordings.ecpp"
    _tnt_cq7.add( "iAvailable_recs", (iAvailable_recs));
#line 313 "recordings.ecpp"
    _tnt_cq7.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 313 "recordings.ecpp"
    _tnt_cq7.add( "iRecItem", (iRecItemRoot));
#line 313 "recordings.ecpp"
    _tnt_cq7.add( "iRecordingsTree", (iRecordingsTree));
#line 313 "recordings.ecpp"
    _tnt_cq7.add( "irecoring_item", (irecoring_item));
#line 313 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[53]; // \n          </ul>\n        </div>\n\t\t\t\t<input type="hidden" name="sort" value="
#line 316 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[54]; // ">\n\t\t\t\t<input type="hidden" name="filter" value="
#line 317 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[55]; // ">\n\t\t\t\t<input type="hidden" name="flat" value="
#line 318 "recordings.ecpp"
  reply.sout() << ( currentFlat );
  reply.out() << _tntChunks[56]; // ">\n\t\t\t\t<input type="hidden" name="history_num_back" value="
#line 319 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[57]; // ">\n        <div class="withmargin hidden-xs">\n          <button class="red" type="submit">
#line 321 "recordings.ecpp"
  reply.sout() << ( tr("Delete selected") );
  reply.out() << _tntChunks[58]; // </button>\n
  reply.out() << _tntChunks[59]; // \n        </div>\n      </form>\n
#line 325 "recordings.ecpp"

    }
std::chrono::duration<double> timeNeeded = std::chrono::high_resolution_clock::now() - timeStart;
dsyslog("live, time recordings.ecpp: %f", timeNeeded.count());

  reply.out() << _tntChunks[60]; //   </div>\n</body>\n</html>\n
  // <%include> page_exit.eh
  reply.out() << _tntChunks[61]; // \n
#line 5 "page_exit.eh"

	spoint.commit();
} catch ( vdrlive::HtmlError const& ex ) {
	tnt::QueryParams param = qparam;
	param.add( "pageTitle", pageTitle );
	param.add( "errorMessage", ex.what() );
	callComp( "error", request, reply, param );
}

  // </%include>
  reply.out() << _tntChunks[62]; // \n
  reply.out() << _tntChunks[63]; // \n\n
  reply.out() << _tntChunks[110]; // \n
  reply.out() << _tntChunks[111]; // \n
  reply.out() << _tntChunks[146]; // \n
  reply.out() << _tntChunks[147]; // \n
  reply.out() << _tntChunks[149]; // \n
  reply.out() << _tntChunks[150]; // \n
  reply.out() << _tntChunks[159]; // \n
  reply.out() << _tntChunks[160]; // \n
  reply.out() << _tntChunks[169]; // \n
  reply.out() << _tntChunks[170]; // \n
  reply.out() << _tntChunks[189]; // \n\n
  reply.out() << _tntChunks[190]; // \n
  reply.out() << _tntChunks[205]; // \n
  reply.out() << _tntChunks[206]; // \n
  reply.out() << _tntChunks[211]; // \n
  reply.out() << _tntChunks[212]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::recordings_item_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::recordings_item " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t iRecItem = qparam.get< uintptr_t >("iRecItem", ( 0));
uintptr_t irecoring_item = qparam.get< uintptr_t >("irecoring_item", ( 0));
uintptr_t iRecordingsTree = qparam.get< uintptr_t >("iRecordingsTree", ( 0));
uintptr_t iOpenTreeNodes = qparam.get< uintptr_t >("iOpenTreeNodes", ( 0));
uintptr_t iAvailable_recs = qparam.get< uintptr_t >("iAvailable_recs", ( 0));
std::string parentIdHash = qparam.get< std::string >("parentIdHash");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 346 "recordings.ecpp"

// define sort order, and reverse (for recordings)
// use current sort order and selected sort option for that
bool reverse = false;
eSortOrder sortOrder = eSortOrder::name; // default
if (currentSort.compare(0, 4,  "date"  , 4) == 0) sortOrder = eSortOrder::date;
if (currentSort.compare(0, 6,  "errors", 6) == 0) sortOrder = eSortOrder::errors;
if (currentSort.compare(0, 8,  "errorsdur", 8) == 0) sortOrder = eSortOrder::durationDeviation;
if (currentSort.compare(0, 10, "duplicates", 10) == 0) sortOrder = eSortOrder::duplicatesLanguage;
if (currentSort == "datedesc" || currentSort == "namedesc") reverse = true;
// get rec item of this (current) dir
RecordingsItemDirPtr recItemThisDir = *(static_cast<RecordingsItemDirPtr *>((void *)iRecItem) );
RecordingsTreePtr recordingsTree = *(static_cast<RecordingsTreePtr *>((void *)iRecordingsTree) );
cLargeString *recoring_item = static_cast<cLargeString *>((void *)irecoring_item );
std::string openTreeNodes= *(static_cast<std::string *>((void *)iOpenTreeNodes) );
std::vector<int> available_recs = *(static_cast<std::vector<int> *>((void *)iAvailable_recs) );
int level = recItemThisDir->Level();


std::vector<RecordingsItemRecPtr> recItems;
const std::vector<RecordingsItemRecPtr> *recItemsC = NULL;

// data for dirs, and loop over dirs
const std::vector<RecordingsItemDirPtr> *dirItems = recItemThisDir->getDirs();
std::vector<RecordingsItemDirPtr>::const_iterator dirIterS, dirIterE, dirIter;
int direction; // for dirs
if (currentFlat != "true") {
  if (currentSort != "duplicates") {
// list of subdirs
    if (!recItemThisDir->dirEntriesSorted() && currentSort == "namedesc") {
// reverse loop over subdirs
      dirIterS = dirItems->end();
      dirIterE = dirItems->begin();
      direction = 0;
    } else {
// forward loop over subdirs
      dirIterS = dirItems->begin();
      dirIterE = dirItems->end();
      direction = 1;
    }
    for (dirIter = dirIterS; dirIter != dirIterE; std::advance(dirIter, direction) ) {
      if(direction == 0) dirIter--;
// this is the loop over the subdirs
// each subdir is a node, which can be expanded (or not)
// each subdir has an identifier in <ul> tag: fldr_<$ idHash $>
      RecordingsItemDirPtr recItem = *dirIter;

      /* search trough directory for new recordings */
      bool newR = false;
      if ( LiveSetup().GetMarkNewRec() ) newR = recItem->checkNew();
// calculate idHash: uniquely defines this node
      std::string idHash(xxHash32(concat(parentIdHash, recItem->Name())));
      iRecItem = (uintptr_t)&recItem;
  
  reply.out() << _tntChunks[64]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 401 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[65]; // ')">\n        <table><tr>\n          
#line 403 "recordings.ecpp"
 if(level > 0) { 
  reply.out() << _tntChunks[66]; //             <td class = "space">\n              <img src="img/transparent.png" width="
#line 405 "recordings.ecpp"
  reply.sout() << ( 16*level );
  reply.out() << _tntChunks[67]; // px" height="16px" />\n            </td>\n          
#line 407 "recordings.ecpp"
 } 
  reply.out() << _tntChunks[68]; //           <td class="space">\n            <img class="recording_expander" src="
#line 409 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[69]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 411 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[70]; // folder_closed.png" />\n          </td>\n
#line 413 "recordings.ecpp"
         if (!recItem->scraperImage().path.empty() ) {

  reply.out() << _tntChunks[71]; //             <td class = space>\n              <div class="thumb">\n                <img data-src="/tvscraper/
#line 416 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().path );
  reply.out() << _tntChunks[72]; // "\n                  class="
#line 417 "recordings.ecpp"
  reply.sout() << ( recItem->scraperImage().width > recItem->scraperImage().height?"thumb":"thumbpt" );
  reply.out() << _tntChunks[73]; // "\n                />\n              </div>\n            </td>\n
#line 421 "recordings.ecpp"
         }

  reply.out() << _tntChunks[74]; //         <td class="recording_folder_name
#line 422 "recordings.ecpp"
  reply.sout() << ( (newR ? "_new" : "") );
  reply.out() << _tntChunks[75]; // ">\n          
#line 423 "recordings.ecpp"
  reply.sout() << ( recItem->Name() );
  reply.out() << _tntChunks[76]; // \n        </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 426 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[77]; // " class="recordingslist" style="display: none;">\n          
  // <& recordings.recordings_item ...
  { 
#line 427 "recordings.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "iAvailable_recs", (iAvailable_recs));
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "iOpenTreeNodes", (iOpenTreeNodes));
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "iRecItem", (iRecItem));
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "iRecordingsTree", (iRecordingsTree));
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "irecoring_item", (irecoring_item));
#line 427 "recordings.ecpp"
    _tnt_cq8.add( "parentIdHash", (idHash));
#line 427 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "recordings_item"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[78]; // \n        </ul>\n      </li>\n      
#line 430 "recordings.ecpp"

    } // end of loop over subdirs
// now the items
    recItemsC = recItemThisDir->getRecordings(sortOrder);
    if (recItemThisDir->recEntriesSorted() ) reverse = false;
  } // end if (currentSort != "duplicates")
} else {
// here we prepare the items in case of a flat list, no folders
  if (currentSort != "duplicates") { 
    recItems.clear();
    size_t max_items = 100;
    if (reverse) {
      reverse = false;
      std::vector<RecordingsItemRecPtr>::const_iterator recIterFirst = recordingsTree->allRecordings(sortOrder)->begin();
      std::vector<RecordingsItemRecPtr>::const_iterator recIterLast  = recordingsTree->allRecordings(sortOrder)->end();
      for (; recIterFirst != recIterLast;) {
        --recIterLast;
        RecordingsItemRecPtr recItem = *recIterLast;
        if (!recItem->matchesFilter(currentFilter)) continue;
        recItems.push_back(recItem);
        if (recItems.size() >= max_items) break;
      }
     } else {
      for (const RecordingsItemRecPtr &rPtr: *recordingsTree->allRecordings(sortOrder) ) {
        if (!rPtr->matchesFilter(currentFilter)) continue;
        recItems.push_back(rPtr);
        if (recItems.size() >= max_items) break;
      }
    }
//    recItemsC = recordingsTree->allRecordings(sortOrder);
    recItemsC = &recItems;
  } else {
    recItems.clear();
    addDuplicateRecordingsSd(recItems, recordingsTree);
    addDuplicateRecordingsLang(recItems, recordingsTree);
    addDuplicateRecordingsNoSd(recItems, recordingsTree);
    recItemsC = &recItems;
  }
}
// do we have to get/write the recording details?
// we have to, if currentFlat == true || level == 0 || this folder is open (cookie)
bool write_recs = level == 0 || currentFlat == "true";
if (!write_recs && recItemsC) {
// check: is this folder open (cookie)?
  auto equal_fldf = [parentIdHash](cSv f) { return f.compare(5, std::string_view::npos, parentIdHash) == 0; };
  cSplit splitOpenTreeNodes(openTreeNodes, ',');
  write_recs = std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end();
}
if (write_recs && recItemsC) {
// in case of duplicates, and not flat, the recItemsC is not available
  
  reply.out() << _tntChunks[79]; // <script>\n  
#line 482 "recordings.ecpp"

  for (const RecordingsItemRecPtr &rPtr: *recItemsC) {
    recoring_item->clear();
    rPtr->AppendAsJSArray(*recoring_item);
  
  reply.out() << _tntChunks[80]; // recs[
#line 487 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[81]; // ]=[
#line 487 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[82]; // ]\n
#line 488 "recordings.ecpp"
 }

  reply.out() << _tntChunks[83]; // </script>\n  
#line 490 "recordings.ecpp"

}
if (currentSort != "duplicates" || currentFlat == "true") {
  if (recItemsC->empty() ) { 
  reply.out() << _tntChunks[84]; //     <script>\n      rec_ids["fldr_
#line 495 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[85]; // "] = []\n    </script>\n  
#line 497 "recordings.ecpp"
 } else {
    bool first = true;
//    const char *displayFolder = currentFlat == "true"?"1":"0";
    const char *displayFolder = "1";
    recoring_item->clear();
    RecordingsItemRec::AppendAsJSArray(*recoring_item, recItemsC->begin(), recItemsC->end(), first, currentFilter, reverse);
    
  reply.out() << _tntChunks[86]; //       <script>\n
#line 505 "recordings.ecpp"
   if (level == 0) {

  reply.out() << _tntChunks[87]; //       document.write(rec_string_d([
#line 506 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[88]; // , 
#line 506 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[89]; // , [ 
#line 506 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[90]; //  ]]))\n
#line 507 "recordings.ecpp"
   } else {

  reply.out() << _tntChunks[91]; //       rec_ids["fldr_
#line 508 "recordings.ecpp"
  reply.sout() << ( parentIdHash );
  reply.out() << _tntChunks[92]; // "] = [
#line 508 "recordings.ecpp"
  reply.sout() << (level);
  reply.out() << _tntChunks[93]; // , 
#line 508 "recordings.ecpp"
  reply.sout() << (displayFolder);
  reply.out() << _tntChunks[94]; // , [ 
#line 508 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[95]; //  ]]\n
#line 509 "recordings.ecpp"
   }

  reply.out() << _tntChunks[96]; //       </script>\n    
#line 511 "recordings.ecpp"

  }
} else {
// duplicates
  for (int i = 0; i < 3; i++) {
    recItems.clear();
    std::string nodeName;
    if (i == 0) {
      addDuplicateRecordingsSd(recItems, recordingsTree);
      nodeName = tr("Duplicates identified by tvscraper");
    } else if (i == 1) {
      addDuplicateRecordingsLang(recItems, recordingsTree);
      nodeName = tr("Duplicates, with different languages");
    } else if (i == 2) {
      addDuplicateRecordingsNoSd(recItems, recordingsTree);
      nodeName = tr("Duplicates not identified by tvscraper");
    }
    if (!recItems.empty() ) {
      std::string idHash(xxHash32(nodeName));
// do we have to get/write the recording details?
// check: is this folder open (cookie)?
      auto equal_fldf = [idHash](cSv f) { return f.compare(5, std::string_view::npos, idHash) == 0; };
      cSplit splitOpenTreeNodes(openTreeNodes, ',');
      if (std::find_if(splitOpenTreeNodes.begin(), splitOpenTreeNodes.end(), equal_fldf) != splitOpenTreeNodes.end()) {
        
  reply.out() << _tntChunks[97]; // <script>\n        
#line 537 "recordings.ecpp"

        for (const RecordingsItemRecPtr &rPtr: recItems) {
          recoring_item->clear();
          rPtr->AppendAsJSArray(*recoring_item);
          
  reply.out() << _tntChunks[98]; // recs[
#line 542 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(rPtr->IdI())));
  reply.out() << _tntChunks[99]; // ]=[
#line 542 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[100]; // ]\n
#line 543 "recordings.ecpp"
       }

  reply.out() << _tntChunks[101]; // </script>\n      
#line 545 "recordings.ecpp"

      }
      bool first = true;
      recoring_item->clear();
      RecordingsItemRec::AppendAsJSArray(*recoring_item, recItems.begin(), recItems.end(), first, currentFilter, false);
      
  reply.out() << _tntChunks[102]; //       <li class="recording">\n        <div class="recording_item" onclick = "tv.Toggle(this, 'fldr_
#line 552 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[103]; // ')">\n          <table><tr><td class="space">\n            <img class="recording_expander" src="
#line 554 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[104]; // plus.png" />\n          </td><td class="space">\n            <img class="recording_folder" src="
#line 556 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[105]; // folder_closed.png" />\n          </td><td class="recording_folder_name">\n            
#line 558 "recordings.ecpp"
  reply.sout() << ( nodeName );
  reply.out() << _tntChunks[106]; // \n          </td></tr></table>\n        </div>\n        <ul id="fldr_
#line 561 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[107]; // " class="recordingslist" style="display: none;">\n          <script>\n            rec_ids["fldr_
#line 563 "recordings.ecpp"
  reply.sout() << ( idHash );
  reply.out() << _tntChunks[108]; // "] = [1, 1, [ 
#line 563 "recordings.ecpp"
  reply.out() << ( recoring_item->c_str() );
  reply.out() << _tntChunks[109]; //  ]]\n          </script>\n        </ul>\n      </li>\n      
#line 567 "recordings.ecpp"

    }
  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::sort_options_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::sort_options " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 576 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[112]; // <span class="label bold">
#line 577 "recordings.ecpp"
  reply.sout() << ( tr("Sort:") );
  reply.out() << _tntChunks[113]; //  </span>\n<a href="recordings.html\?sort=
#line 578 "recordings.ecpp"
  reply.sout() << ( (currentSort == "nameasc") ? "namedesc" : "nameasc");
  reply.out() << _tntChunks[114]; // &filter=
#line 578 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[115]; // &flat=
#line 578 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[116]; // " 
  // <& setactive ...
  { 
#line 578 "recordings.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 578 "recordings.ecpp"
    _tnt_cq9.add( "current", "name");
#line 578 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[117]; //  >
#line 578 "recordings.ecpp"
  reply.sout() << ( tr("Name") );
  reply.out() << _tntChunks[118]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 580 "recordings.ecpp"
  reply.sout() << ( (currentSort == "datedesc") ? "dateasc" : "datedesc");
  reply.out() << _tntChunks[119]; // &filter=
#line 580 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[120]; // &flat=
#line 580 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[121]; // " 
  // <& setactive ...
  { 
#line 580 "recordings.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 580 "recordings.ecpp"
    _tnt_cq10.add( "current", "date");
#line 580 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[122]; //  >
#line 580 "recordings.ecpp"
  reply.sout() << ( tr("Date") );
  reply.out() << _tntChunks[123]; // </a>\n<span class="sep">|</span>\n<a href="recordings.html\?sort=duplicates&filter=
#line 582 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[124]; // &flat=
#line 582 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[125]; // " 
  // <& setactive ...
  { 
#line 582 "recordings.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 582 "recordings.ecpp"
    _tnt_cq11.add( "current", "duplicates");
#line 582 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[126]; //  >
#line 582 "recordings.ecpp"
  reply.sout() << ( tr("Duplicates") );
  reply.out() << _tntChunks[127]; // </a>\n
#line 583 "recordings.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[128]; // <span class="sep">|</span>\n<a href="recordings.html\?sort=
#line 587 "recordings.ecpp"
  reply.sout() << ( (currentSort == "errorsts") ? "errorsdur" : "errorsts" );
  reply.out() << _tntChunks[129]; // &filter=
#line 587 "recordings.ecpp"
  if ( !currentFilter.empty() )
    reply.sout() <<  currentFilter ;
  reply.out() << _tntChunks[130]; // &flat=
#line 587 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[131]; // " 
  // <& setactive ...
  { 
#line 587 "recordings.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 587 "recordings.ecpp"
    _tnt_cq12.add( "current", "errors");
#line 587 "recordings.ecpp"
  main().setactive(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[132]; // >
#line 587 "recordings.ecpp"
  reply.sout() << ( tr("Errors") );
  reply.out() << _tntChunks[133]; // </a>\n
#line 588 "recordings.ecpp"

#endif
#ifdef HAVE_PCRE2

  reply.out() << _tntChunks[134]; // <span class="sep">|</span>\n<span class="label bold">
#line 593 "recordings.ecpp"
  reply.sout() << ( tr("Filter") );
  reply.out() << _tntChunks[135]; // :&nbsp;<input type="text" name="filter" value="
#line 593 "recordings.ecpp"
  reply.sout() << ( currentFilter );
  reply.out() << _tntChunks[136]; // " id="filter" onchange="filterRecordings(this, '
#line 593 "recordings.ecpp"
  reply.sout() << ( currentSort );
  reply.out() << _tntChunks[137]; // ', '
#line 593 "recordings.ecpp"
  reply.sout() << (currentFlat);
  reply.out() << _tntChunks[138]; // ')" />&nbsp;
  // <& tooltip.help ...
  { 
#line 593 "recordings.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 593 "recordings.ecpp"
    _tnt_cq13.add( "text", (tr("Look in recordings titles and subtitles for the given string and display only the matching ones. You may also use perl compatible regular expressions (PCRE).")));
#line 593 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "help"), request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[139]; // </span>\n
#line 594 "recordings.ecpp"

#endif
if (currentFlat != "true") {

  reply.out() << _tntChunks[140]; // <span class="sep">|</span>\n<img onclick="ExpandAll()" src="
#line 599 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "plus.png") );
  reply.out() << _tntChunks[141]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 599 "recordings.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 599 "recordings.ecpp"
    _tnt_cq14.add( "text", (tr("Expand all folders")));
#line 599 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[142]; // />\n<img onclick="CollapseAll()" src="
#line 600 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "minus.png") );
  reply.out() << _tntChunks[143]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 600 "recordings.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 600 "recordings.ecpp"
    _tnt_cq15.add( "text", (tr("Collapse all folders")));
#line 600 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[144]; // />\n
#line 601 "recordings.ecpp"

}

  reply.out() << _tntChunks[145]; // <br />\n
#line 605 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::setactive_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::setactive " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string current = qparam.get< std::string >("current");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 613 "recordings.ecpp"

if (currentSort.compare(0, current.length(), current) == 0) { 
  reply.out() << _tntChunks[148]; // class="active"
#line 614 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::del_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::del_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 626 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[151]; // <a href="epginfo.html\?epgid=del_
#line 626 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[152]; // &sort=
#line 626 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[153]; // &filter=
#line 626 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[154]; // &flat=
#line 626 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[155]; // &history_num_back=
#line 626 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[156]; // " 
  // <& tooltip.hint ...
  { 
#line 626 "recordings.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 626 "recordings.ecpp"
    _tnt_cq16.add( "text", (tr("Delete this recording from hard disc!")));
#line 626 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[157]; // ><img src="
#line 626 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[158]; // " alt="" /></a>
#line 626 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_rec_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::edit_rec " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 638 "recordings.ecpp"
 { 
  reply.out() << _tntChunks[161]; // <a href="edit_recording.html\?recid=
#line 638 "recordings.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[162]; // &sort=
#line 638 "recordings.ecpp"
  reply.sout() << (sort);
  reply.out() << _tntChunks[163]; // &filter=
#line 638 "recordings.ecpp"
  reply.sout() << (filter);
  reply.out() << _tntChunks[164]; // &flat=
#line 638 "recordings.ecpp"
  reply.sout() << (flat);
  reply.out() << _tntChunks[165]; // &history_num_back=
#line 638 "recordings.ecpp"
  reply.sout() << (history_num_back+1);
  reply.out() << _tntChunks[166]; // "><img src="
#line 638 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "edit.png") );
  reply.out() << _tntChunks[167]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 638 "recordings.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 638 "recordings.ecpp"
    _tnt_cq17.add( "text", (tr("Edit recording")));
#line 638 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[168]; //  /></a>
#line 638 "recordings.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::todel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::todel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string todel = qparam.get< std::string >("todel");
std::string confirmed = qparam.get< std::string >("confirmed");
std::string history_num_back = qparam.get< std::string >("history_num_back");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 648 "recordings.ecpp"

  RecordingsManagerPtr recordings = LiveRecordingsManager();
  const cRecording *recording = recordings->GetByMd5Hash(todel);
  if (recording == nullptr)
    throw HtmlError(tr("Couldn't find recording or no recordings available"));
  if (!cUser::CurrentUserHasRightTo(UR_DELRECS))
    throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );
  if (confirmed == "confirmed") {
    RemoveRecordingTask task(todel);
    LiveTaskManager().Execute(task);

  reply.out() << _tntChunks[171]; // <!DOCTYPE html>\n<html>\n  <script>\n    history.go(-
#line 662 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[172]; // );\n  </script>\n</html>\n
#line 665 "recordings.ecpp"
  } else {

  reply.out() << _tntChunks[173]; // <div class="epg_description" id="del_
#line 666 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[174]; // ">\n  <div class="station">\n    <div class="boxheader"><div><div class="caption">
#line 668 "recordings.ecpp"
  reply.sout() << ( tr("Delete recordings") );
  reply.out() << _tntChunks[175]; // </div></div></div>\n  </div>\n  <div class="epg_content">\n    <form>\n      <div class="about_head"><div><div>
#line 672 "recordings.ecpp"
  reply.sout() << ( cSv(cToSvFormated(tr("Delete recording \"%s\"?"), recording->Name()?recording->Name():"No recording name available")) );
  reply.out() << _tntChunks[176]; // </div></div></div>\n      <input type="hidden" name="epgid" value="
#line 673 "recordings.ecpp"
  reply.sout() << (todel);
  reply.out() << _tntChunks[177]; // " >\n      <input type="hidden" name="delete_rec" value="confirmed" >\n      <input type="hidden" name="history_num_back" value="
#line 675 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[178]; // " id="history_del_
#line 675 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[179]; // ">\n      <div class="about_left">\n        <button id="confirm_del_
#line 677 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[180]; // " class="green" type="button" onclick="delete_rec_back('
#line 677 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[181]; // ', 
#line 677 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[182]; // )">
#line 677 "recordings.ecpp"
  reply.sout() << ( tr("Delete"));
  reply.out() << _tntChunks[183]; // </button>\n      </div>\n      <div class="about_right">\n
  reply.out() << _tntChunks[184]; // \n<script>\nfunction cancel_delete() {\n  if (document.referrer.indexOf("epginfo.html\?") != -1) {\n    history.go(-1);\n  } else {\n    history.go(-
#line 686 "recordings.ecpp"
  reply.sout() << ( history_num_back );
  reply.out() << _tntChunks[185]; // );\n  }\n}\n</script>\n        <button id="close_del_
#line 690 "recordings.ecpp"
  reply.sout() << ( todel );
  reply.out() << _tntChunks[186]; // " type="button" class="red" onclick="back_depending_referrer(1, 
#line 690 "recordings.ecpp"
  reply.sout() << (history_num_back );
  reply.out() << _tntChunks[187]; // )">
#line 690 "recordings.ecpp"
  reply.sout() << ( tr("Cancel") );
  reply.out() << _tntChunks[188]; // </button>\n      </div>\n    </form>\n  </div>\n</div>\n
#line 695 "recordings.ecpp"
 }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::rec_tools_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::rec_tools " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string id = qparam.get< std::string >("id");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
std::string sort = qparam.get< std::string >("sort");
std::string filter = qparam.get< std::string >("filter");
std::string flat = qparam.get< std::string >("flat");
int history_num_back = qparam.get< int >("history_num_back", ( 0));
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
#line 710 "recordings.ecpp"
   if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  // <& pageelems.ajax_action_href ...
  { 
#line 711 "recordings.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 711 "recordings.ecpp"
    _tnt_cq18.add( "action", "play_recording");
#line 711 "recordings.ecpp"
    _tnt_cq18.add( "alt", "");
#line 711 "recordings.ecpp"
    _tnt_cq18.add( "image", "play.png");
#line 711 "recordings.ecpp"
    _tnt_cq18.add( "param", (id));
#line 711 "recordings.ecpp"
    _tnt_cq18.add( "tip", (tr("play this recording")));
#line 711 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[191]; // \n
#line 712 "recordings.ecpp"
   }

  // <& pageelems.m3u_playlist_recording ...
  { 
#line 713 "recordings.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 713 "recordings.ecpp"
    _tnt_cq19.add( "recid", (id));
#line 713 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_recording"), request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[192]; // \n
  // <& pageelems.imdb_info_href ...
  { 
#line 714 "recordings.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 714 "recordings.ecpp"
    _tnt_cq20.add( "s_IMDB_ID", (s_IMDB_ID));
#line 714 "recordings.ecpp"
    _tnt_cq20.add( "title", (title));
#line 714 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[193]; // \n
  // <& recordings.edit_rec ...
  { 
#line 715 "recordings.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 715 "recordings.ecpp"
    _tnt_cq21.add( "filter", (filter));
#line 715 "recordings.ecpp"
    _tnt_cq21.add( "flat", (flat));
#line 715 "recordings.ecpp"
    _tnt_cq21.add( "history_num_back", (history_num_back));
#line 715 "recordings.ecpp"
    _tnt_cq21.add( "id", (id));
#line 715 "recordings.ecpp"
    _tnt_cq21.add( "sort", (sort));
#line 715 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "edit_rec"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[194]; // \n
  // <& recordings.del_rec ...
  { 
#line 716 "recordings.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 716 "recordings.ecpp"
    _tnt_cq22.add( "filter", (filter));
#line 716 "recordings.ecpp"
    _tnt_cq22.add( "flat", (flat));
#line 716 "recordings.ecpp"
    _tnt_cq22.add( "history_num_back", (history_num_back));
#line 716 "recordings.ecpp"
    _tnt_cq22.add( "id", (id));
#line 716 "recordings.ecpp"
    _tnt_cq22.add( "sort", (sort));
#line 716 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "del_rec"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[195]; // \n
#line 717 "recordings.ecpp"

const cRecording* recording = NULL;
if (!id.empty()) recording = LiveRecordingsManager()->GetByMd5Hash(id);
if (recording && recording->Info() ) {
  int recordingErrors = -1;
#if VDRVERSNUM >= 20505
  recordingErrors = recording->Info()->Errors();
#endif

  cGetScraperVideo getScraperVideo(NULL, recording);
  bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
  if (scraperDataAvailable) {
    int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
    char sdhd = video_SD_HD == 0 ? 's': video_SD_HD == 1 ? 'h': 'u';
    std::string duration;
    if (recording->FileName() )
      AppendDuration(duration, tr("%d:%02d"), recording->LengthInSeconds() );

  reply.out() << _tntChunks[196]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 736 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[197]; // "></span>\n<script class="injectIcons">\ninjectErrorHdSdIcon("icons-
#line 738 "recordings.ecpp"
  reply.sout() << (id);
  reply.out() << _tntChunks[198]; // ", 
#line 738 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(recordingErrors)));
  reply.out() << _tntChunks[199]; // , 
#line 738 "recordings.ecpp"
  reply.sout() << (cSv(cToSvInt(getScraperVideo.m_scraperVideo->getDurationDeviation())));
  reply.out() << _tntChunks[200]; // , "
#line 738 "recordings.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[201]; // ", "
#line 738 "recordings.ecpp"
  reply.sout() << (cSv(recording->Info()->ChannelName()));
  reply.out() << _tntChunks[202]; // ", "
#line 738 "recordings.ecpp"
  reply.sout() << (duration);
  reply.out() << _tntChunks[203]; // ", 
#line 738 "recordings.ecpp"
  reply.sout() << ( GetNumberOfTsFiles(recording) );
  reply.out() << _tntChunks[204]; // )\n</script>\n
#line 740 "recordings.ecpp"

  }
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::archived_disc_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::archived_disc " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string archived = qparam.get< std::string >("archived");
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  reply.out() << _tntChunks[207]; // <img src="
#line 753 "recordings.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[208]; // " alt="on_dvd" 
  // <& tooltip.hint ...
  { 
#line 753 "recordings.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 753 "recordings.ecpp"
    _tnt_cq23.add( "text", (archived));
#line 753 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[209]; //  />\n
  // <& pageelems.imdb_info_href ...
  { 
#line 754 "recordings.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 754 "recordings.ecpp"
    _tnt_cq24.add( "s_IMDB_ID", (s_IMDB_ID));
#line 754 "recordings.ecpp"
    _tnt_cq24.add( "title", (title));
#line 754 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[210]; // \n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::delete_error_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("recordings::delete_error " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 35 "recordings.ecpp"
  typedef bool logged_in_type;
  TNT_SESSION_SHARED_VAR(bool, logged_in, (false));   // <%session> bool logged_in(false)
  _tnt_ignore_unused<logged_in_type>(logged_in);
#line 40 "recordings.ecpp"
  typedef std::string currentSort_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentSort, ());   // <%request> std::string currentSort
  _tnt_ignore_unused<currentSort_type>(currentSort);
#line 41 "recordings.ecpp"
  typedef std::string deleteResult_type;
  TNT_REQUEST_SHARED_VAR(std::string, deleteResult, ());   // <%request> std::string deleteResult
  _tnt_ignore_unused<deleteResult_type>(deleteResult);
#line 42 "recordings.ecpp"
  typedef std::string currentFilter_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFilter, ());   // <%request> std::string currentFilter
  _tnt_ignore_unused<currentFilter_type>(currentFilter);
#line 43 "recordings.ecpp"
  typedef std::string currentFlat_type;
  TNT_REQUEST_SHARED_VAR(std::string, currentFlat, ());   // <%request> std::string currentFlat
  _tnt_ignore_unused<currentFlat_type>(currentFlat);
#line 9 "page_init.eh"
  typedef std::string pageTitle_type;
  TNT_REQUEST_SHARED_VAR(std::string, pageTitle, ());   // <%request> std::string pageTitle
  _tnt_ignore_unused<pageTitle_type>(pageTitle);
  // <%cpp>
  // <& recordings.sort_options ...
  { 
#line 759 "recordings.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 759 "recordings.ecpp"
    callComp(tnt::Subcompident(std::string(), "recordings", "sort_options"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[213]; // \n
#line 760 "recordings.ecpp"
 { reply.out() << deleteResult; } 
  // <%/cpp>
  return DEFAULT;
}

} // namespace
